expandanint[exp_] := 
  Block[{jj, kk, genericres, expandedint, tempallints, tempsym, 
    allints, preGenuine2Lfuncs, tempres, dels, delcoeff, remainints},
   badints = {};

   Check[expandedint = 
      SeriesCoefficient[(ExpandDel[
                  exp /. yintreds //. myextraTreps //. ctintreds /. 
                    yintreds /. ssintreds /. $D -> 
                    4 - 2 del /. {T[Df[k2, x_] Df[k3, y_] Df[k4, z_]] -> 
                    T[Df[k2, x] Df[k3, y] Df[k4, z]][p2], 
                    T[Df[k1, u_] Df[k2, x_] Df[k3, y_] Df[k4, z_]] -> 
                    T[Df[k1, u] Df[k2, x] Df[k3, y] Df[k4, z]][p2], 
                    T[Df[k2, x_]^2 Df[k3, y_] Df[k4, z_]] -> 
                    T[Df[k2, x]^2 Df[k3, y] Df[k4, z]][p2], 
                    T[Df[k1, u_] Df[k2, x_] Df[k3, y_] Df[k4, z_] Df[
                    k5, w_]] -> 
                    T[Df[k1, u] Df[k2, x] Df[k3, y] Df[k4, z] Df[k5, 
                    w]][p2], 
                    T[Df[k1, u_]^2 Df[k2, x_] Df[k3, y_] Df[k4, 
                    z_]] -> 
                    T[Df[k1, u]^2 Df[k2, x] Df[k3, y] Df[k4, z]][
                    p2]}] //. 
                 Delta[x_, y_, z_] -> 
                  x^2 + y^2 + z^2 - 2 x*y - 2 x*z - 2 y*z /. 
                newtcrules /. newtyrules /. newttrules //. 
             tdivrules //. tsildict //. extraUrep4 //. srep2 //. 
         extraUrep4), {del, 0, 0}];
    ,
    (* If error occurs do this*)
    
    Print["Error in integral reduction"];
    allints = 
     Cases[genericres, _T | _Y | _TOneLoop | _YOneLoop, Infinity];
    Print[allints];
    For[jj = 1, jj <= Length[allints], jj++,
     tempres = 
      Check[SeriesCoefficient[(ExpandDel[
                   allints[[jj]] /. yintreds //. myextraTreps //. 
                    ctintreds /. yintreds /. ssintreds /. $D -> 
                    4 - 2 del /. {T[
                    Df[k2, x_] Df[k3, y_] Df[k4, z_]] -> 
                    T[Df[k2, x] Df[k3, y] Df[k4, z]][p2], 
                    T[Df[k1, u_] Df[k2, x_] Df[k3, y_] Df[k4, z_]] -> 
                    T[Df[k1, u] Df[k2, x] Df[k3, y] Df[k4, z]][p2], 
                    T[Df[k2, x_]^2 Df[k3, y_] Df[k4, z_]] -> 
                    T[Df[k2, x]^2 Df[k3, y] Df[k4, z]][p2], 
                    T[Df[k1, u_] Df[k2, x_] Df[k3, y_] Df[k4, z_] Df[
                    k5, w_]] -> 
                    T[Df[k1, u] Df[k2, x] Df[k3, y] Df[k4, z] Df[k5, 
                    w]][p2], 
                    T[Df[k1, u_]^2 Df[k2, x_] Df[k3, y_] Df[k4, 
                    z_]] -> 
                    T[Df[k1, u]^2 Df[k2, x] Df[k3, y] Df[k4, z]][
                    p2]}] //. 
                  Delta[x_, y_, z_] -> 
                   x^2 + y^2 + z^2 - 2 x*y - 2 x*z - 2 y*z /. 
                 newtcrules /. newtyrules /. newttrules //. 
              tdivrules //. tsildict //. extraUrep4 //. srep2 //. 
          extraUrep4), {del, 0, 0}]
       ,
       Print["Problematic integral is ", allints[[jj]]];
       AppendTo[badints, allints[[jj]]];
       0;
       ];
     expandedint = 0;
     
     ];
    
    ];(* End check *)
   
   remainints = Union[Cases[expandedint, _Tfin | _Yfin, Infinity]];
   If[remainints =!= {},
    Print[" Expression contains some unreduced integrals!! ", remainints];
    ];
   
   If[expandedint =!= 0,

    tempallints = 
     Intersection[
      Cases[expandedint, _SMS | _SMI | _SMM | _SMV | _SMU | _SMTT | \
_SMTbar, Infinity]];
    tempsym = symmetry[tempallints];
    expandedint = 
     Collect[expandedint /. 
       tempsym, _B0del | _B0fin | _SMS | _SMI | _SMM | _SMU | _SMV | \
_SMTT | _SMTbar, Simplify];
    ];
   dels = Intersection[Cases[expandedint, _B0del, Infinity]];
   If[Length[dels] > 0,
    
    For[jj = 1, jj <= Length[dels], jj++,
      delcoeff = 
       Simplify[
        Coefficient[
         expandedint /. {Delta[x_, y_, z_] -> 
            x^2 + y^2 + z^2 - 2 x*y - 2 x*z - 2 y*z}, dels[[jj]]]];
      If[delcoeff =!= 0,
       Print["B0dels remain: ", dels[[jj]], " -> ", delcoeff];
       ];
      ];
    ];
Return[expandedint]
       ];


SimpleCollect[expr_List] := SimpleCollect[#] & /@ expr;
ordercoupsrep = {VVVV[x_, y_, z_, u_, w_] :> 
    VVVV[Sequence @@ (Sort[{{x, y, z, u}, {y, x, u, z}, {z, u, x, 
           y}, {u, z, y, x}}][[1]]), w], 
   SSS[x_, y_, z_, u_] :> SSS[Sequence @@ Sort[{x, y, z}], u], 
   SSSS[x_, y_, z_, u_, 1] :> SSSS[Sequence @@ Sort[{x, y, z, u}], 1],
    SVV[x_, y_, z_, u_] :> SVV[x, Sequence @@ Sort[{y, z}], u], 
   VVV[x_, y_, z_, u_] :> 
    Signature[{x, y, z}]*VVV[Sequence @@ Sort[{x, y, z}], u], 
   SSVV[x_, y_, z_, u_, w_] :> 
    SSVV[Sequence @@ Sort[{x, y}], Sequence @@ Sort[{z, u}], w], 
   FFS[x_, y_, z_, u_] :> FFS[Sequence @@ Sort[{x, y}], z, u], 
   FFV[x_, y_, z_, u_] :> 
    If[OrderedQ[{x, y}], FFV[x, y, z, u], -FFV[y, x, z, 3 - u]], 
   SSV[x_, y_, z_, u_] :> 
    Signature[{x, y}]*SSV[Sequence @@ Sort[{x, y}], z, u]};
SimpleCollect[expr_] := 
  Block[{coups, pexp, lexp, coupstrings, ii, jj, coeff, total, pos, 
    res, reprule, ghostcoups, ginds, uuvinds, repr, tcoup, fourcount1,
     fourcount2, fourcount3, fourcount, allints, symrep},
   coups = 
    Intersection[
     Cases[{expr}, _SUU | _SSS | _SVV | _SSSS | _SSV | _FFV | _FFS | \
_VVV | _VVVV | _UUV | _SSVV, Infinity]];
   
   repr = {};
   For[ii = 1, ii <= Length[coups], ii++,
    tcoup = coups[[ii]] /. ordercoupsrep;
    AppendTo[repr, coups[[ii]] -> tcoup];
    ];
   pexp = expr /. repr;
   pexp = 
    ExpandAll[
     pexp(*,_SSS|_SSSS|_SSV|_SVV|_FFV|_FFS|_VVV|_VVVV|_UUV|_SSVV|_SUU|\
_SVV*)];
   lexp = If[Head[pexp] === Plus, List @@ pexp, {pexp}];
   total = {};
   (* Now each term should be a product of couplings times a \
coefficient *)
   
   For[ii = 1, ii <= Length[lexp], ii++,
    coups = 
     Sort[Cases[
       lexp[[ii]], _SSS | _SSSS | _SSV | _FFV | _FFS | _VVV | _VVVV | \
_UUV | _SSVV | _SUU | _SVV, Infinity]];
    If[coups === {},

     
     If[lexp[[ii]] =!= 0,
       Print[Style["Error: term without couplings", Red, Large, Bold],
          lexp[[ii]]];
       ,
       Continue[];
       ];
     ];
    coeff = lexp[[ii]] /. Map[# -> 1 &, coups];
    pos = Position[total, coups];
    If[pos === {},
     AppendTo[total, {coups, coeff}];
     ,
     total[[pos[[1, 1]], 2]] += coeff;
     ];(* If ... *)
    ]; (* For ...*)

   (* Now collect together the terms by loop function*)
   
   For[ii = 1, ii <= Length[total], ii++,

    total[[ii, 2]] = 
      Collect[total[[ii, 
        2]], _B0 | _T | _Y | _TOneLoop | _YOneLoop | _B0fin | _B0del \
| _SMI | _SMS | _SMU | _SMV | _SMTT | _SMTbar | _SMM, Simplify];
    ];
   
   Return[total];
   
   ];
CouplingCollect[expr_List] := CouplingCollect[#] & /@ expr;
CouplingCollect[expr_] := Block[{tmp},
   tmp = SimpleCollect[expr];
   Return[Total[(Times @@ #[[1]])*#[[2]] & /@ tmp]]
   ];