(* Cut down from TwoCalc file *)

ExpandDel[expr_] := expr  /.
  Divergence -> 1/del /. Dminus4 -> -2 del /.
  { A0[m_] :> m/del + A0fin[m] + A0del[m] del,
    B0[a__] :> 1/del + B0fin[a] + B0del[a] del,
    B1[a__] :> -1/(2 del) + B1fin[a] + B1del[a] del,
    DB0[a__] :> DB0fin[a] + DB0del[a] del,
    DB1[a__] :> DB1fin[a] + DB1del[a] del,
    DB00[a__] :> -1/(12 del) + DB00fin[a] + DB00del[a] del,
    DB11[a__] :> DB11fin[a] + DB11del[a] del,
    DB001[a__] :> 1/(24 del) + DB001fin[a] + DB001del[a] del,
    DC0i[n__][a__] :> DC0ifin[n][a] + DC0idel[n][a] del,
    T[dfs_] :> Tdiv2[dfs]/del^2 + Tdiv[dfs]/del + Tfin[dfs],
    Y[dfs_] :> Ydiv2[dfs]/del^2 + Ydiv[dfs]/del + Yfin[dfs],
    T[dfs_][p2_] :> Tdiv2[dfs][p2]/del^2 + Tdiv[dfs][p2]/del + Tfin[dfs][p2],
    Y[dfs_][p2_] :> Ydiv2[dfs][p2]/del^2 + Ydiv[dfs][p2]/del + Yfin[dfs][p2],
    $D -> 4 - 2 del } 


Conjugate[a_A0] ^:= a


Unprotect[Times];
Re[B0fin[0, 0, m_] x_.] ^:= B0fin[0, 0, m] Re[x];
Re[B0del[0, 0, m_] x_.] ^:= B0del[0, 0, m] Re[x];
Protect[Times];
Conjugate[B0fin[0, 0, m_]] ^:= B0fin[0, 0, m];
Conjugate[B0del[0, 0, m_]] ^:= B0del[0, 0, m];


B1fin[0, m0_, m1_] :=
  -1/2 B0fin[0, m0, m1] + (m1 - m0)/2 DB0fin[0, m0, m1];
B1del[0, m0_, m1_] :=
  -1/2 B0del[0, m0, m1] + (m1 - m0)/2 DB0del[0, m0, m1];
B1fin[p_, m0_, m1_] :=
  1/(2 p) (A0fin[m0] - A0fin[m1] - (p - m1 + m0) B0fin[p, m0, m1]);
B1del[p_, m0_, m1_] :=
  1/(2 p) (A0del[m0] - A0del[m1] - (p - m1 + m0) B0del[p, m0, m1]);

B0fin[0, 0, 0] = 0;
B0del[0, 0, 0] = 0;
(*
B0fin[p_, m_, 0] := B0fin[p, 0, m] /; m =!= 0;
B0del[p_, m_, 0] := B0del[p, 0, m] /; m =!= 0;
*)
B0fin[0, m_, m_] := B0fin[0, 0, m] - 1;
B0del[0, m_, m_] := B0del[0, 0, m] - B0fin[0, 0, m];
B0fin[0, m0_, m1_] :=
  (m1 B0fin[0, 0, m1] - m0 B0fin[0, 0, m0])/(m1 - m0) /; m0 =!= 0;
B0del[0, m0_, m1_] :=
  (m1 B0del[0, 0, m1] - m0 B0del[0, 0, m0])/(m1 - m0) /; m0 =!= 0;
B0del[p_, m1_, m2_] := B0del[p, m2, m1] /; !OrderedQ[{m1, m2}];
B0fin[p_, m1_, m2_] := B0fin[p, m2, m1] /; !OrderedQ[{m1, m2}];


DB0fin[0, 0, 0] = 0;
DB0fin[0, m_, m_] := 1/(6 m);
DB0fin[0, m1_, m2_] := 1/(m1 - m2)^2 (
  (m1 + m2)/2 - A0fin[m2] + m2 B0fin[0, m1, m2] );
DB0del[0, 0, 0] = 0;

A0fin[m_] := m B0fin[0, 0, m];
A0del[m_] := m B0del[0, 0, m];

C0ifin[cc0, 0, 0, 0, m_, m_, m_] := -1/(2 m);
C0idel[cc0, 0, 0, 0, m_, m_, m_] := -1/(2 m) B0fin[0, m, m];



